#pragma once

#include <stddef.h>
#include "gp/allocator/allocator.hpp"

namespace gp {
	struct dummy_allocator : public allocator {
		/**
		 * @return nullptr, always
		 */
		virtual void* allocate(size_t)
		{
			return nullptr;
		}

		/**
		 * @return false, always
		 */
		virtual bool deallocate(void*) 
		{
			return false;
		}

		/**
		 * @return false, always
		 */
		virtual bool try_reallocate(void*, size_t) {
			return false;
		}
		virtual ~dummy_allocator() = default;
	};
}